package testmodel.diagramA.part;

import java.util.List;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.ui.URIEditorInput;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.transaction.TransactionalEditingDomain;
import org.eclipse.emf.transaction.util.TransactionUtil;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.diagram.core.preferences.PreferencesHint;
import org.eclipse.gmf.runtime.diagram.core.services.ViewService;
import org.eclipse.gmf.runtime.emf.commands.core.command.AbstractTransactionalCommand;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.HintedDiagramLinkStyle;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;

public class TestModelDiagramOpenTypeBCommand extends AbstractTransactionalCommand 
	{
	/**
	 * @generated
	 */
	private final HintedDiagramLinkStyle diagramFacet;

	/**
	 * @generated
	 */
	TestModelDiagramOpenTypeBCommand(HintedDiagramLinkStyle linkStyle) 
		{
		// editing domain is taken for original diagram, 
		// if we open diagram from another file, we should use another editing domain
		super(TransactionUtil.getEditingDomain(linkStyle), Messages.CommandName_OpenDiagram, null);
		diagramFacet = linkStyle;
		}

	// FIXME canExecute if  !(readOnly && getDiagramToOpen == null), i.e. open works on ro diagrams only when there's associated diagram already
	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException 
		{
		try 
			{
			Diagram diagram = getDiagramToOpen();
			
			if (diagram == null) 
				{diagram = intializeNewDiagram();}
			
			URI uri = EcoreUtil.getURI(diagram);
			String editorName = uri.lastSegment() + '#' + diagram.eResource().getContents().indexOf(diagram);
			IEditorInput editorInput = new URIEditorInput(uri, editorName);
			IWorkbenchPage page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
			page.openEditor(editorInput, getEditorID());
			return CommandResult.newOKCommandResult();
			}
		catch (Exception ex) 
			{throw new ExecutionException("Can't open diagram", ex);}
		}

	/**
	 * @generated
	 */
	protected Diagram getDiagramToOpen() 
		{return diagramFacet.getDiagramLink();}

	/**
	 * @generated 
	 */
	protected Diagram intializeNewDiagram() throws ExecutionException
		{
		// MOD Update added to ensure the required elements are added to the diagram
		EObject diagramDomainElement = getDiagramDomainElement();

		// Create the diagram using the element that was updated
		Diagram d = ViewService.createDiagram(diagramDomainElement,
				getDiagramKind(), getPreferencesHint());
		// endMOD
		if (d == null) 
			{throw new ExecutionException("Can't create diagram of '" + getDiagramKind() + "' kind");}
		
		diagramFacet.setDiagramLink(d);
		assert diagramFacet.eResource() != null;
		diagramFacet.eResource().getContents().add(d);
		return d;
		}


	/**
	 * @generated
	 */
	protected EObject getDiagramDomainElement() 
		{
		// use same element as associated with EP
		return ((View) diagramFacet.eContainer()).getElement();
		}

	/**
	 * @generated
	 */
	protected PreferencesHint getPreferencesHint() 
		{
		// XXX prefhint from target diagram's editor?
		return TestModelDiagramEditorPlugin.DIAGRAM_PREFERENCES_HINT;
		}

	/**
	 * @generated
	 */
	protected String getDiagramKind() 
		{
		return "TestModelB";
		}

	/**
	 * @generated
	 */
	protected String getEditorID() {
		return "testmodel.diagramB.part.TestModelDiagramEditorID";
	}
}
