package testmodel.diagramA.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

import testmodel.TestCanvas;
import testmodel.TestmodelPackage;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class TestModelVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "net.london3d.gmf.diagramA/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (testmodel.diagramA.edit.parts.TestCanvasEditPart.MODEL_ID
					.equals(view.getType())) {
				return testmodel.diagramA.edit.parts.TestCanvasEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return testmodel.diagramA.part.TestModelVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				testmodel.diagramA.part.TestModelDiagramEditorPlugin
						.getInstance().logError(
								"Unable to parse view type as a visualID number: "
										+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (TestmodelPackage.eINSTANCE.getTestCanvas().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((TestCanvas) domainElement)) {
			return testmodel.diagramA.edit.parts.TestCanvasEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = testmodel.diagramA.part.TestModelVisualIDRegistry
				.getModelID(containerView);
		if (!testmodel.diagramA.edit.parts.TestCanvasEditPart.MODEL_ID
				.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (testmodel.diagramA.edit.parts.TestCanvasEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = testmodel.diagramA.part.TestModelVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = testmodel.diagramA.edit.parts.TestCanvasEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case testmodel.diagramA.edit.parts.TestCanvasEditPart.VISUAL_ID:
			if (TestmodelPackage.eINSTANCE.getTypeA().isSuperTypeOf(
					domainElement.eClass())) {
				return testmodel.diagramA.edit.parts.TypeAEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = testmodel.diagramA.part.TestModelVisualIDRegistry
				.getModelID(containerView);
		if (!testmodel.diagramA.edit.parts.TestCanvasEditPart.MODEL_ID
				.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (testmodel.diagramA.edit.parts.TestCanvasEditPart.MODEL_ID
				.equals(containerModelID)) {
			containerVisualID = testmodel.diagramA.part.TestModelVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = testmodel.diagramA.edit.parts.TestCanvasEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case testmodel.diagramA.edit.parts.TestCanvasEditPart.VISUAL_ID:
			if (testmodel.diagramA.edit.parts.TypeAEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case testmodel.diagramA.edit.parts.TypeAEditPart.VISUAL_ID:
			if (testmodel.diagramA.edit.parts.TypeANameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(TestCanvas element) {
		return true;
	}

}
